﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TestProject
{
    /// <summary>
    /// connection
    /// </summary>
    public class connection
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 연결 ID - cid

        /// <summary>
        /// 연결 ID
        /// </summary>
        public long cid { get; set; }

        #endregion
        #region IP 주소 - ip

        /// <summary>
        /// IP 주소
        /// </summary>
        public string ip { get; set; }

        #endregion
        #region 포트 - port

        /// <summary>
        /// 포트
        /// </summary>
        public int port { get; set; }

        #endregion
        #region 시작 시간 - start

        /// <summary>
        /// 시작 시간
        /// </summary>
        public DateTime start { get; set; }

        #endregion
        #region 마지막 활동 시간 - last_activity

        /// <summary>
        /// 마지막 활동 시간
        /// </summary>
        public DateTime last_activity { get; set; }

        #endregion
        #region RTT - rtt

        /// <summary>
        /// RTT
        /// </summary>
        public string rtt { get; set; }

        #endregion
        #region UP 시간 - uptime

        /// <summary>
        /// UP 시간
        /// </summary>
        public string uptime { get; set; }

        #endregion
        #region 보류 바이트 수 - pending_bytes

        /// <summary>
        /// 보류 바이트 수
        /// </summary>
        public long pending_bytes { get; set; }

        #endregion
        #region 입력 메시지 수 - in_msgs

        /// <summary>
        /// 입력 메시지 수
        /// </summary>
        public long in_msgs { get; set; }

        #endregion
        #region 출력 메시지 수 - out_msgs

        /// <summary>
        /// 출력 메시지 수
        /// </summary>
        public long out_msgs { get; set; }

        #endregion
        #region 입력 바이트 수 - in_bytes

        /// <summary>
        /// 입력 바이트 수
        /// </summary>
        public long in_bytes { get; set; }

        #endregion
        #region 출력 바이트 수 - out_bytes

        /// <summary>
        /// 출력 바이트 수
        /// </summary>
        public long out_bytes { get; set; }

        #endregion
        #region 구독 수 - subscriptions

        /// <summary>
        /// 구독 수
        /// </summary>
        public long subscriptions { get; set; }

        #endregion
        #region 프로그래밍 언어 - lang

        /// <summary>
        /// 프로그래밍 언어
        /// </summary>
        public string lang { get; set; }

        #endregion
        #region 버전 - version

        /// <summary>
        /// 버전
        /// </summary>
        public string version { get; set; }

        #endregion
        #region 구독 리스트 - subscriptions_list

        /// <summary>
        /// 구독 리스트
        /// </summary>
        public List<string> subscriptions_list { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString(indentCount)

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <param name="indentCount">들여쓰기 카운트</param>
        /// <returns>문자열</returns>
        public string ToString(int indentCount = 0)
        {
            string indentString = " ".GetRepeatString(indentCount);

            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"{indentString}cid           : {cid          }");
            stringBuilder.AppendLine($"{indentString}ip            : {ip           }");
            stringBuilder.AppendLine($"{indentString}port          : {port         }");
            stringBuilder.AppendLine($"{indentString}start         : {start        }");
            stringBuilder.AppendLine($"{indentString}last_activity : {last_activity}");
            stringBuilder.AppendLine($"{indentString}rtt           : {rtt          }");
            stringBuilder.AppendLine($"{indentString}uptime        : {uptime       }");
            stringBuilder.AppendLine($"{indentString}pending_bytes : {pending_bytes}");
            stringBuilder.AppendLine($"{indentString}in_msgs       : {in_msgs      }");
            stringBuilder.AppendLine($"{indentString}out_msgs      : {out_msgs     }");
            stringBuilder.AppendLine($"{indentString}in_bytes      : {in_bytes     }");
            stringBuilder.AppendLine($"{indentString}out_bytes     : {out_bytes    }");
            stringBuilder.AppendLine($"{indentString}subscriptions : {subscriptions}");
            stringBuilder.AppendLine($"{indentString}lang          : {lang         }");
            stringBuilder.AppendLine($"{indentString}version       : {version      }");

            if(subscriptions_list != null && subscriptions_list.Count > 0)
            {
            stringBuilder.AppendLine($"{indentString}subscriptions_list");
            stringBuilder.AppendLine($"{indentString}--------------------------------------------------");

            for(int i = 0; i < subscriptions_list.Count; i++)
            {
                stringBuilder.AppendLine($"{indentString}    {subscriptions_list[i]}");
            }

            stringBuilder.AppendLine($"{indentString}--------------------------------------------------");
            }

            return stringBuilder.ToString();
        }

        #endregion
    }

    /// <summary>
    /// connz
    /// </summary>
    public class connz
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 서버 ID - server_id

        /// <summary>
        /// 서버 ID
        /// </summary>
        public string server_id { get; set; }

        #endregion
        #region 현재 시간 - now

        /// <summary>
        /// 현재 시간
        /// </summary>
        public DateTime now { get; set; }

        #endregion
        #region 연결 수 - num_connections

        /// <summary>
        /// 연결 수
        /// </summary>
        public long num_connections { get; set; }

        #endregion
        #region 전체 수 - total

        /// <summary>
        /// 전체 수
        /// </summary>
        public long total { get; set; }

        #endregion
        #region 오프셋 - offset

        /// <summary>
        /// 오프셋
        /// </summary>
        public long offset { get; set; }

        #endregion
        #region 제한 - limit

        /// <summary>
        /// 제한
        /// </summary>
        public long limit { get; set; }

        #endregion
        #region 연결 리스트 - connections

        /// <summary>
        /// 연결 리스트
        /// </summary>
        public List<connection> connections { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"server_id       : {server_id      }");
            stringBuilder.AppendLine($"now             : {now            }");
            stringBuilder.AppendLine($"num_connections : {num_connections}");
            stringBuilder.AppendLine($"total           : {total          }");
            stringBuilder.AppendLine($"offset          : {offset         }");
            stringBuilder.AppendLine($"limit           : {limit          }");

            if(connections != null && connections.Count > 0)
            {
            stringBuilder.AppendLine($"connections");
            stringBuilder.AppendLine($"--------------------------------------------------");

            for(int i = 0; i < connections.Count; i++)
            {
                connection connection = connections[i];

                if(i > 0)
                {
                    stringBuilder.AppendLine();
                }

                stringBuilder.AppendLine(connection.ToString(4));
            }

            stringBuilder.AppendLine($"--------------------------------------------------");
            }

            return stringBuilder.ToString();
        }

        #endregion
    }
}