﻿using System;
using System.Collections.Generic;
using System.Text;

namespace TestProject
{
    /// <summary>
    /// route
    /// </summary>
    public class route
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 라우팅 ID - rid

        /// <summary>
        /// 라우팅 ID
        /// </summary>
        public int rid { get; set; }

        #endregion
        #region 원격 ID - remote_id

        /// <summary>
        /// 원격 ID
        /// </summary>
        public string remote_id { get; set; }

        #endregion
        #region DID SOLICIT - did_solicit

        /// <summary>
        /// DID SOLICIT
        /// </summary>
        public bool did_solicit { get; set; }

        #endregion
        #region 구성 여부 - is_configured

        /// <summary>
        /// 구성 여부
        /// </summary>
        public bool is_configured { get; set; }

        #endregion
        #region IP 주소 - ip

        /// <summary>
        /// IP 주소
        /// </summary>
        public string ip { get; set; }

        #endregion
        #region 포트 - port

        /// <summary>
        /// 포트
        /// </summary>
        public int port { get; set; }

        #endregion
        #region 보류 크기 - pending_size

        /// <summary>
        /// 보류 크기
        /// </summary>
        public long pending_size { get; set; }

        #endregion
        #region 입력 메시지 수 - in_msgs

        /// <summary>
        /// 입력 메시지 수
        /// </summary>
        public long in_msgs { get; set; }

        #endregion
        #region 출력 메시지 수 - out_msgs

        /// <summary>
        /// 출력 메시지 수
        /// </summary>
        public long out_msgs { get; set; }

        #endregion
        #region 입력 바이트 수 - in_bytes

        /// <summary>
        /// 입력 바이트 수
        /// </summary>
        public long in_bytes { get; set; }

        #endregion
        #region 출력 바이트 수 - out_bytes

        /// <summary>
        /// 출력 바이트 수
        /// </summary>
        public long out_bytes { get; set; }

        #endregion
        #region 구독 수 - subscriptions

        /// <summary>
        /// 구독 수
        /// </summary>
        public int subscriptions { get; set; }

        #endregion
        #region 구독 리스트 - subscriptions_list

        /// <summary>
        /// 구독 리스트
        /// </summary>
        public List<string> subscriptions_list { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString(indentCount)

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <param name="indentCount">들여쓰기 카운트</param>
        /// <returns>문자열</returns>
        public string ToString(int indentCount = 0)
        {
            string indentString = " ".GetRepeatString(indentCount);

            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"{indentString}rid           : {rid          }");
            stringBuilder.AppendLine($"{indentString}remote_id     : {remote_id    }");
            stringBuilder.AppendLine($"{indentString}did_solicit   : {did_solicit  }");
            stringBuilder.AppendLine($"{indentString}is_configured : {is_configured}");
            stringBuilder.AppendLine($"{indentString}ip            : {ip           }");
            stringBuilder.AppendLine($"{indentString}port          : {port         }");
            stringBuilder.AppendLine($"{indentString}pending_size  : {pending_size }");
            stringBuilder.AppendLine($"{indentString}in_msgs       : {in_msgs      }");
            stringBuilder.AppendLine($"{indentString}out_msgs      : {out_msgs     }");
            stringBuilder.AppendLine($"{indentString}in_bytes      : {in_bytes     }");
            stringBuilder.AppendLine($"{indentString}out_bytes     : {out_bytes    }");
            stringBuilder.AppendLine($"{indentString}subscriptions : {subscriptions}");
            stringBuilder.AppendLine($"{indentString}subscriptions_list");
            stringBuilder.AppendLine($"{indentString}--------------------------------------------------");
            if(subscriptions_list != null && subscriptions_list.Count > 0)
            {
                foreach(string subscription in subscriptions_list)
                {
                    stringBuilder.AppendLine($"{indentString}    {subscription}");
                }
            }
            stringBuilder.AppendLine($"{indentString}--------------------------------------------------");

            return stringBuilder.ToString();
        }

        #endregion
    }

    /// <summary>
    /// routez
    /// </summary>
    public class routez
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 서버 ID - server_id

        /// <summary>
        /// 서버 ID
        /// </summary>
        public string server_id { get; set; }

        #endregion
        #region 현재 시간 - now

        /// <summary>
        /// 현재 시간
        /// </summary>
        public DateTime now { get; set; }

        #endregion
        #region 라우팅 리스트 - routes

        /// <summary>
        /// 라우팅 리스트
        /// </summary>
        public List<route> routes { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"server_id         : {server_id        }");
            stringBuilder.AppendLine($"now               : {now              }");

            stringBuilder.AppendLine($"routes");
            stringBuilder.AppendLine($"--------------------------------------------------");
            if(routes != null && routes.Count > 0)
            {
                foreach(route route in routes)
                {
                    stringBuilder.AppendLine(route.ToString(4));
                }
            }
            stringBuilder.AppendLine($"--------------------------------------------------");

            return stringBuilder.ToString();
        }

        #endregion
    }
}