﻿using System.Collections.Generic;
using System.Text;

namespace TestProject
{
    /// <summary>
    /// subscription
    /// </summary>
    public class subscription
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 서브젝트 - subject

        /// <summary>
        /// 서브젝트
        /// </summary>
        public string subject { get; set; }

        #endregion
        #region 서브젝트 ID - sid

        /// <summary>
        /// 서브젝트 ID
        /// </summary>
        public int sid { get; set; }

        #endregion
        #region 메시지 수 - msgs

        /// <summary>
        /// 메시지 수
        /// </summary>
        public long msgs { get; set; }

        #endregion
        #region 클러스터 ID - cid

        /// <summary>
        /// 클러스터 ID
        /// </summary>
        public int cid { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString(indentCount)

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <param name="indentCount">들여쓰기 카운트</param>
        /// <returns>문자열</returns>
        public string ToString(int indentCount = 0)
        {
            string indentString = " ".GetRepeatString(indentCount);

            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"{indentString}subject : {subject}");
            stringBuilder.AppendLine($"{indentString}sid     : {sid    }");
            stringBuilder.AppendLine($"{indentString}msgs    : {msgs   }");
            stringBuilder.AppendLine($"{indentString}cid     : {cid    }");

            return stringBuilder.ToString();
        }

        #endregion
    }

    /// <summary>
    /// subsz
    /// </summary>
    public class subsz
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 구독 수 - num_subscriptions

        /// <summary>
        /// 구독 수
        /// </summary>
        public long num_subscriptions { get; set; }

        #endregion
        #region 캐시 수 - num_cache

        /// <summary>
        /// 캐시 수
        /// </summary>
        public long num_cache { get; set; }

        #endregion
        #region 삽입 수 - num_inserts

        /// <summary>
        /// 삽입 수
        /// </summary>
        public long num_inserts { get; set; }

        #endregion
        #region 제거 수 - num_removes

        /// <summary>
        /// 제거 수
        /// </summary>
        public long num_removes { get; set; }

        #endregion
        #region 매칭 수 - num_matches

        /// <summary>
        /// 매칭 수
        /// </summary>
        public long num_matches { get; set; }

        #endregion
        #region 캐시 히트 비율 - cache_hit_rate

        /// <summary>
        /// 캐시 히트 비율
        /// </summary>
        public double cache_hit_rate { get; set; }

        #endregion
        #region 최대 FANOUT - max_fanout

        /// <summary>
        /// 최대 FANOUT
        /// </summary>
        public double max_fanout { get; set; }

        #endregion
        #region 평균 FANOUT - avg_fanout

        /// <summary>
        /// 평균 FANOUT
        /// </summary>
        public double avg_fanout { get; set; }

        #endregion
        #region 전체 수 - total

        /// <summary>
        /// 전체 수
        /// </summary>
        public long total { get; set; }

        #endregion
        #region 오프셋 - offset

        /// <summary>
        /// 오프셋
        /// </summary>
        public long offset { get; set; }

        #endregion
        #region 제한 수 - limit

        /// <summary>
        /// 제한 수
        /// </summary>
        public long limit { get; set; }

        #endregion
        #region 구독 리스트 - subscriptions_list

        /// <summary>
        /// 구독 리스트
        /// </summary>
        public List<subscription> subscriptions_list { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"num_subscriptions : {num_subscriptions}");
            stringBuilder.AppendLine($"num_cache         : {num_cache        }");
            stringBuilder.AppendLine($"num_inserts       : {num_inserts      }");
            stringBuilder.AppendLine($"num_removes       : {num_removes      }");
            stringBuilder.AppendLine($"num_matches       : {num_matches      }");
            stringBuilder.AppendLine($"cache_hit_rate    : {cache_hit_rate   }");
            stringBuilder.AppendLine($"max_fanout        : {max_fanout       }");
            stringBuilder.AppendLine($"avg_fanout        : {avg_fanout       }");
            stringBuilder.AppendLine($"total             : {total            }");
            stringBuilder.AppendLine($"offset            : {offset           }");
            stringBuilder.AppendLine($"limit             : {limit            }");

            if(subscriptions_list != null && subscriptions_list.Count > 0)
            {
            stringBuilder.AppendLine($"subscriptions_list");
            stringBuilder.AppendLine($"--------------------------------------------------");

            for(int i = 0; i < subscriptions_list.Count; i++)
            {
                subscription subscription = subscriptions_list[i];

                if(i > 0)
                {
                    stringBuilder.AppendLine();
                }

                stringBuilder.AppendLine(subscription.ToString(4));
            }

            stringBuilder.AppendLine($"--------------------------------------------------");
            }

            return stringBuilder.ToString();
        }

        #endregion
    }
}